/**
 *  Created:     25. 2. 2019 by Petra Sečkařová (xsecka02@stud.fit.vutbr.cz).
 *  Filename:    fileLocation.cpp
 *
 *  Description: Implementation of methods for a class representing a location in a file.
 */

#include <sstream>
#include "fileLocation.h"

fileLocation::fileLocation(int line, int column, const std::string &fileName) : line(line), column(column),
                                                                                 fileName(fileName) {}

int fileLocation::getLine() const {
    return line;
}

int fileLocation::getColumn() const {
    return column;
}

const std::string &fileLocation::getFileName() const {
    return fileName;
}

fileLocation::fileLocation() {
    line = -1;
    column = -1;
    fileName = "";
}

std::string fileLocation::printLocation() const {
    std::ostringstream print;
    print << fileName << ":" << line << ":" << column;
    return print.str();
}
