/**
 *  Created:     25. 2. 2019 by Petra Sečkařová (xsecka02@stud.fit.vutbr.cz).
 *  Filename:    fileLocation.h
 *
 *  Description: Declaration of class representing a location in a file,
 *               given by line, column and filename.
 */

#ifndef SRC_FILELOCATION_H
#define SRC_FILELOCATION_H


#include <string>

class fileLocation {

private:
    int line;
    int column;
    std::string fileName;
public:

    fileLocation(int line, int column, const std::string &fileName);

    fileLocation();

    const std::string &getFileName() const;

    std::string printLocation() const;

    int getLine() const;

    int getColumn() const;

};


#endif //SRC_FILELOCATION_H
