//
// Created by seckarovap on 1/16/19.
//

#ifndef SRC_SPECTRA_H
#define SRC_SPECTRA_H

#include "T-Props-Checker/formulaAnalyser.h"
#include "T-Props-Checker/monitorCreator.h"
#include <libgen.h>
#include <cstring>
#include <getopt.h>


/****************  DEFINITIONS  ****************/

#define FORMULA_FILE "examples/TPC-formula.ltl"
#define DEFS_FILE "TPC-defs.h"

enum TPCIndexes {FORMULAE, DECLARATIONS};


/*****************  FUNCTIONS  *****************/

/**
 * Prints help message to stdout.
 */
void printHelp();

/**
 * Prints help message for T-Props Checker to stdout.
 */
void printTPCHelp();

/**
 * Tries to parse arguments for T-Props Checker tool.
 * Loads names of definitions header and formulae file given as '-d defs.h' and '-f formulae.ltl' in any order.
 * @param argc The count of given arguments.
 * @param argv The contents of the given arguments, argv[0] == name of this program, argv[1] == '--tpc'.
 * @param fileNames A pointer where to store the loaded file names.
 * @return True if arguments processed successfully, false otherwise.
 */
bool parsedArgsForTPC(int argc, char** argv, std::string* fileNames);

#endif //SRC_SPECTRA_H
