# Spectra - Testos

This folder contains test sets for each implemented tool. The tests are
deployed by the `make test` command here or in the parent folder. The project
compilation is performed at the beginning of the testing. Tests for each tool
are controlled by a separate script as described below or run as a [Google
Test](https://github.com/google/googletest) test suite from
[tests_main.cpp](tests/tests_main.cpp).

New tests using Google Test framework can be added simply by writing a new
test suite as files
[formulaAnalyserTest.h](tests/T-Props-Checker/formulaAnalyserTest.h) and
[formulaAnalyserTest.cpp](tests/T-Props-Checker/formulaAnalyserTest.cpp), and
add the source code in the list *TEST_SRC* in the Makefile in this folder.
These tests are monitored by *LCOV*, when being executed.  Coverage results can
be generated into the [coverage](tests/coverage) folder using `make stats`
command.

## T-Props Checker

The first part of tests for this tool is controlled by the
[tpc-test.sh](tests/T-Props-Checker/tpc-test.sh) bash script. TEST 0 verifies
reaction of the tool when no other parameters than *--tpc* were given.

Tests 1-9 verify correct functionality of the temporal operators on 9
specification files containing formulae with their semantics expressions. These
are tested with a simple C language program counting from 0 to 9. 

The second part is implemented as unit tests using Google Test framewrok. These
tests are created for the *formulaAnalyser* and *monitorCreator* classes of the
T-Props Checker tool.

The tests for *formulaAnalyser* have two parts - the first checks results of
each function in every possible calling context and the second tests correct
reactions on various correctly and incorrectly written specification files. 

The tests for *monitorCreator* are also partialy function-wise, but they also
contain system tests using simple specification files containing always just
ane formula using one by one all of the supported operators, for which the
preparation anf verification expretions are checked in the generated monitor
code.
