#!/bin/bash
# Author: Petra Sečkařová xsecka02@stud.fit.vutbr.cz
# Last changed: 9.4.2019 

files=( "since" "since1" "glob" "prev" "up" "down" "int" "int1" "xor" )

desc=( "Strong vs. Weak Since" "Weak Since Definition" "Globally" "Previously" \
"Up" "Down" "Strong vs. Weak Interval" "Weak Interval Definition" "Xor" )

failed=false


cp ../spectra ./
./spectra --tpc > out.txt
HELP=$(diff out.txt help-msg.txt)
rm -f out.txt

echo "--- TEST 0 --- Help"

if [ "$HELP" != "" ] 
then
    echo "The help message was modified."
else
    echo "OK"
fi

total=${#files[*]}

for (( i=0; i < $(( $total )); i++ ))
do
  echo "--- TEST $((${i}+1)) --- ${desc[$i]}"
  echo ./spectra --tpc -s specifications/${files[$i]}.spec -d definitions/defs.h
  ./spectra --tpc -s specifications/${files[$i]}.spec -d definitions/defs.h
  if [ $? != 0 ]
  then
    failed=true
    echo "FAILED: not able to generate monitor"
  else
      echo gcc -Wall -L. -I. SUT/sequence.c -lspectra -o sut-prog
      if gcc -Wall -L. -I. SUT/sequence.c -lspectra -o sut-prog; then
        ./sut-prog 2> err.txt
        if [ -s err.txt ]
        then
          failed=true
          echo "FAILED: verification failed"
        else
          echo "OK"
        fi
        rm -f err.txt sut-prog sequence.o
      else
        failed=true
        echo "FAILED: not able to compile SUT"
      fi
      rm -f monitor.* libspectra.a
  fi 
done

rm -f spectra 
